//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//
///////////
// Headers
#include <allegro.h>
#include "airdrop.h"
#include "particles.h"
#include "frame_play.h"
#include "player.h"
#include "images.h"
#include "audio.h"


///////////////
// Constructor
AirDrop::AirDrop(bool enemy,double target_x) {
 	IsEnemy = enemy;
	int dir = 1;
	AirDropping = 1;
	if (IsEnemy) {
		dir = -1;
		AirDropping = 2;
	}
	x = target_x - 1200*dir;
	y = -600;
	vx = dir*10;
	timer = 0;
	bmp = Images.GetImage("enemy_bomb.bmp");
	pivotX = 0;
	pivotY = 0;
}


//////////////
// Destructor
AirDrop::~AirDrop() {
	AirDropping = 0;
}


//////////
// Update
void AirDrop::Update() {
	timer++;

	// Bomb
	if (timer % 15 == 0) {
		Particle *part;
		if (IsEnemy) part=SpawnParticle(Particle_Enemy_Bomb,0,0);
		else part=SpawnParticle(Particle_Friendly_Bomb,0,0);
		part->vx = vx*0.7;
		part->vy = 0;
		part->Update();
	}

	// Timeout
	if (timer == 200) {
		Destroy();
		return;
	}

	// Move
	x += vx;

	// Update as sprite
	//Sprite::Update();
}


////////////////////////
// Try to create a drop
void AirDrop::TryAirDrop(FramePlay *parent) {
	NextDrop--;
	if (NextDrop < 0) {
		// Setup
		NextDrop = 1000+rand()%2000;
		int EnemyChance = 50 + int(parent->Player->x/250.0);
		bool Enemy = false;
		if (rand()%100 < EnemyChance) Enemy = true;

		// Spawn
		AirDrop *drop = new AirDrop(Enemy,parent->Player->x + rand()%100 - 50);
		parent->AddSprite(drop);

		// Sound
		int start = 0;
		if (Enemy) start = 255;
		SAMPLE *sound = Audio.GetSample("airplane.wav");
		int vol = int(Audio.GetVolume() * 255.0f);
 		int voice = play_sample(sound, vol, start, 1000, 0);
		voice_sweep_pan(voice, 2000, 255-start);
	}
}


//////////
// Static
int AirDrop::NextDrop;
int AirDrop::AirDropping;
