//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//

#ifndef ANIMATION_H
#define ANIMATION_H


///////////
// Headers
#include <vector>
#include <map>


//////////////
// Prototypes
struct BITMAP;
class Animation;


///////////////////
// Animation frame
class AnimationFrame {
public:
	BITMAP *bmp;
	int pivotX;
	int pivotY;
	int len;
};


//////////////////////
// Animation sequence
class AnimationSequence {
public:
	std::vector<AnimationFrame> seq;
	int NextSequence;
	AnimationSequence();
};


////////////
// Typedefs
typedef std::vector<AnimationSequence*> AnimationGroup;
typedef std::map<std::string,Animation*> AnimationMap;


///////////////////
// Animation class
class Animation {
public:
	AnimationGroup group;
	static void Init();
	static AnimationMap AnimationsBlueprints;
	static Animation *GetAnimation(std::string name);
};

#endif
