//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef AUDIO_H
#define AUDIO_H


///////////
// Headers
#include <vector>
#include <string>
#include <map>


//////////////
// Prototypes
struct DUH;
struct AL_DUH_PLAYER;
struct SAMPLE;


///////////////
// Audio class
class AudioClass {
private:
	std::vector<DUH*> musics;
	std::map<std::string,SAMPLE*> samples;
	AL_DUH_PLAYER *Current;
	int curMusic;
	float volume;

public:
	AudioClass();
	~AudioClass();

	void AddMusic(std::string name);
	void PlayNext();
	void Init();
	void Update();
	SAMPLE *GetSample(std::string name);
	void VolumeUp();
	void VolumeDown();
	float GetVolume() { return volume; }
};


//////////
// Global
extern AudioClass Audio;

#endif
