//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//
///////////
// Headers
#include "collectible.h"
#include "images.h"
#include "frame_play.h"
#include "player.h"
#include "audio.h"


///////////////
// Constructor
Item::Item(double _x,double _y,int type) {
	ItemType = type;
	x = _x;
	y = _y;
	pivotX = 5;
	pivotY = 10;
	timer = 500;
	switch (ItemType) {
		case 0:	bmp = Images.GetImage("item_01.bmp"); break;
		case 1:	bmp = Images.GetImage("item_02.bmp"); break;
		case 2:	bmp = Images.GetImage("item_03.bmp"); break;
		case 3:	bmp = Images.GetImage("item_04.bmp"); break;
		case 4:	bmp = Images.GetImage("item_05.bmp"); break;
	}
}


//////////
// Update
void Item::Update() {
	// Player got it
	PlayerSoldier *player = playFrame->Player;
	if (player->Alive && CollidesWith(player)) {
		if (ItemType == 0) player->Life = player->MaxLife;
		if (ItemType == 1) {
			player->HasWeapon[1] = true;
			player->Ammo[1] = 50;
			player->Weapon = 1;
		}
		if (ItemType == 2) {
			player->HasWeapon[2] = true;
			player->Ammo[2] = 400;
			player->Weapon = 2;
		}
		if (ItemType == 3) {
			player->HasWeapon[3] = true;
			player->Ammo[3] = 10;
			player->Weapon = 3;
		}
		if (ItemType == 4) {
			player->MaxLife += 50;
			player->Life = player->MaxLife;
		}
		PlaySound("item.wav");
		Destroy();
		return;
	}

	// Countdown to death
	timer--;
	if (timer < 40) {
		Hidden = ((timer/5)%2==0);
	}
	if (timer == 0) {
		Destroy();
		return;
	}

	// Update as object
	Object::Update();
}
