//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef FRAME_BASE_H
#define FRAME_BASE_H


///////////
// Headers
#include <list>


//////////////
// Prototypes
class Sprite;


////////////////////
// Base frame class
class FrameBase {
private:

public:
	std::list<Sprite*> Sprites;
	double scrollX,scrollY;

	FrameBase();
	virtual ~FrameBase();

	void Switch(int n);
	void AddSprite (Sprite *sprite);
	void DestroySprite (Sprite *sprite);
	void DrawSprites(int pos);
	void UpdateSprites();

	virtual bool Update()=0;
	virtual void Draw()=0;
};


#endif
