//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//
///////////
// Headers
#include <allegro.h>
#include "images.h"
#include "core.h"


///////////////
// Constructor
ImagesManager::ImagesManager () {
}


///////
// Get
BITMAP *ImagesManager::GetImage(std::string name) {
	std::map<std::string,BITMAP*>::iterator pos = imgs.find(name);
	if (pos != imgs.end()) return pos->second;

	char buffer[1024];
	std::string pathname = "/images/" + name;
	Core.MakeAbsolutePath(pathname.c_str(),buffer);
	BITMAP *newbmp = load_bitmap(buffer,NULL);
	if (!newbmp) throw "Could not load image";
	imgs[name] = newbmp;
	return newbmp;
}


//////////
// Global
ImagesManager Images;
