//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//
///////////
// Headers
#include <allegro.h>
#include "input.h"


///////////////
// Constructor
InputClass::InputClass() {
	// Reset
	for (int i=0;i<10;i++) {
		Key[i] = false;
		KeyDown[i] = false;
		KeyUp[i] = false;
		KeyPrev[i] = false;
	}
}


//////////
// Update
void InputClass::Update() {
	// Copy current keys to previous buffer
	for (int i=0;i<10;i++) {
		KeyPrev[i] = Key[i];
	}

	// Update Key array
	Key[Key_A] = key[KEY_LCONTROL] != 0 || key[KEY_RCONTROL] != 0;
	Key[Key_B] = key[KEY_SPACE] != 0;
	Key[Key_Start] = key[KEY_ENTER] != 0;
	Key[Key_Select] = key[KEY_TAB] != 0;
	Key[Key_Left] = key[KEY_LEFT] != 0;
	Key[Key_Right] = key[KEY_RIGHT] != 0;
	Key[Key_Up] = key[KEY_UP] != 0;
	Key[Key_Down] = key[KEY_DOWN] != 0;
	Key[Key_Minus] = key[KEY_MINUS] != 0;
	Key[Key_Plus] = key[KEY_EQUALS] != 0;

	// Update joystick
	poll_joystick();
	int joy_n = 0;
	if (num_joysticks > 0) {
		Key[Key_A] |= joy[joy_n].button[3].b != 0;
		Key[Key_B] |= joy[joy_n].button[0].b != 0;
		Key[Key_Select] |= joy[joy_n].button[6].b != 0;
		Key[Key_Start] |= joy[joy_n].button[7].b != 0;
		Key[Key_Left] |= joy[joy_n].stick[0].axis[0].d1 != 0;
		Key[Key_Right] |= joy[joy_n].stick[0].axis[0].d2 != 0;
		Key[Key_Up] |= joy[joy_n].stick[0].axis[1].d1 != 0;
		Key[Key_Down] |= joy[joy_n].stick[0].axis[1].d2 != 0;
		Key[Key_Minus] |= joy[joy_n].button[8].b != 0;
		Key[Key_Plus] |= joy[joy_n].button[9].b != 0;
	}

	// Update up and down arrays
	for (int i=0;i<10;i++) {
		if (Key[i] && !(KeyPrev[i])) KeyDown[i] = true;
		else KeyDown[i] = false;

		if (!(Key[i]) && KeyPrev[i]) KeyUp[i] = true;
		else KeyUp[i] = true;
	}
}


///////////////////
// Global instance
InputClass Input;
