//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef OBJECT_H
#define OBJECT_H


///////////
// Headers
#include "sprite.h"


//////////////
// Prototypes
class FramePlay;
class Particle;


////////////////
// Object class
class Object: public Sprite {
protected:
	FramePlay *playFrame;

public:
	int HeightSupport;
	bool DieOnHit;
	bool BackOnHit;
	double DragX;
	double DragY;
	double GravityEffect;
	double GroundDrag;
	double Bounce;
	double vx,vy;

	Object();

	Particle *SpawnParticle(int n,int spawnX,int spawnY);
	bool IsOnGround();
	void Update();
	void SetParent(FrameBase *parent);
	int GetSoundPan();
	int GetSoundVolume();
	void PlaySound(const char* name);
	bool CollidesWith(Object *target);
};


#endif
