//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef SOLDIER_H
#define SOLDIER_H


///////////
// Headers
#include "object.h"


//////////////
// Prototypes
class Building;


/////////////////
// Soldier class
class Soldier: public Object {
protected:
	int shootCooldown;
	int Type;
	int Direction;
	int timer;
	double angle;
	double speed;

	void Move(double dir);
	void Stop();
	void Jump();
	void Shoot();
	virtual void Die();
	void Destroy();
	void Capture(Building *build);
	void NextWeapon();
	bool HasBetterWeapon();
	Building *OverBuilding();

public:
	bool HasWeapon[4];
	int Ammo[4];
	int PointsWorth;
	int Weapon;
	double MaxLife;
	double Life;
	bool IsAI;
	Building *Inside;
	bool IsEnemy;
	bool Alive;
	double DamageMultiply;

	Soldier(double x,bool enemy);
	virtual ~Soldier();
	
	virtual void Update();
	void Heal(double amount);
	void Damage(double amount,Object *From=NULL);
};


#endif
